### Bienvenido

<div align="center">
<p>
    <a href="https://www.npmjs.com/package/collectors"><img src="https://nodei.co/npm/collectors.png?downloads=true&stars=true" alt="Banner del npm"></a>
    <a href="https://www.npmjs.com/package/collectors"><img src="https://img.shields.io/npm/dt/collectors.svg?maxAge=3600" alt="Descargas del npm"></a>
  </p>
</div>

+ ### Un npm para crear una collection

---
+ ## Que es una collection?

Una collection es un `Map()` pero "mejorado"

En si una collection es un map pero con mas metodos

Inicializacion
-
```
npm install collectors@latest
```
---
Como inicio creando un Collector?

---
+ **Primero, iniciamos requiriendo el npm y usando la clase**
---
```js
const Collection = require("collectors") //Requerimos el npm
const Collector = new Collection() //Iniciamos creando un nuevo collector
```
---
+ **Despues tendremos que usar los metodos para agregar datos al collector**
---
Cambios recientes
-
+ **Se agregaron los [findKey](https://www.npmjs.com/package/collectors#findkey) y [findValue](https://www.npmjs.com/package/collectors#findvalue) que buscan un key o value que cumpla con algo**
+ **Se agregaron los [randomKey](https://www.npmjs.com/package/collectors#randomkey) y [randomValue](https://www.npmjs.com/package/collectors#randomvalue) que te dan un key o un value random del Collector**
+ **Se agregaron los [hasAll](https://www.npmjs.com/package/collectors#hasall) y [hasAny](https://www.npmjs.com/package/collectors#hasany) que te dicen si el Collector tiene todos los keys que pones o si solo tiene algunos**
+ **Se agrego el [findAndDelete](https://www.npmjs.com/package/collectors#findanddelete) que hace la funcion del [find](https://www.npmjs.com/package/collectors#find) pero cuando lo encuentre eliminara este dato**
+ **Se agrego el [equalsValues](https://www.npmjs.com/package/collectors#equalsvalues) que hace la funcion del [equals](https://www.npmjs.com/package/collectors#equals) pero con los values**
---
Metodos (32)
---
+ [**`set`**](https://www.npmjs.com/package/collectors#set)
+ [**`remove`**](https://www.npmjs.com/package/collectors#remove)
+ [**`reset`**](https://www.npmjs.com/package/collectors#reset)
+ [**`get`**](https://www.npmjs.com/package/collectors#get)
+ [**`update`**](https://www.npmjs.com/package/collectors#update)
+ [**`map`**](https://www.npmjs.com/package/collectors#map)
+ [**`mapValues`**](https://www.npmjs.com/package/collectors#mapvalues)
+ [**`mapKeys`**](https://www.npmjs.com/package/collectors#mapkeys)
+ [**`every`**](https://www.npmjs.com/package/collectors#every)
+ [**`some`**](https://www.npmjs.com/package/collectors#some)
+ [**`clone`**](https://www.npmjs.com/package/collectors#clone)
+ [**`first`**](https://www.npmjs.com/package/collectors#first)
+ [**`last`**](https://www.npmjs.com/package/collectors#last)
+ [**`find`**](https://www.npmjs.com/package/collectors#find)
+ [**`findAndDelete`**](https://www.npmjs.com/package/collectors#findanddelete)
+ [**`findKey`**](https://www.npmjs.com/package/collectors#findkey)
+ [**`findValue`**](https://www.npmjs.com/package/collectors#findvalue)
+ [**`filter`**](https://www.npmjs.com/package/collectors#filter)
+ [**`random`**](https://www.npmjs.com/package/collectors#random)
+ [**`randomKey`**](https://www.npmjs.com/package/collectors#randomkey)
+ [**`randomValue`**](https://www.npmjs.com/package/collectors#randomvalue)
+ [**`has`**](https://www.npmjs.com/package/collectors#has)
+ [**`sort`**](https://www.npmjs.com/package/collectors#sort)
+ [**`forEach`**](https://www.npmjs.com/package/collectors#foreach)
+ [**`equals`**](https://www.npmjs.com/package/collectors#equals)
+ [**`equalsValues`**](https://www.npmjs.com/package/collectors#equalsvalues)
+ [**`concat`**](https://www.npmjs.com/package/collectors#concat)
+ [**`position`**](https://www.npmjs.com/package/collectors#position)
+ [**`hasAll`**](https://www.npmjs.com/package/collectors#hasall)
+ [**`hasAny`**](https://www.npmjs.com/package/collectors#hasany)
+ [**`toJson`**](https://www.npmjs.com/package/collectors#tojson)
+ [**`toString`**](https://www.npmjs.com/package/collectors#tojson)
---
### set
Estableces un dato en el Collector
```js
Collector.set("Key", ['Value one', 'Value two']) //return Collector
```
### remove
Eliminas un dato del Collector
```js
Collector.remove("Key") //return Collector
```
### reset
Reseteas el Collector
```js
Collector.reset() //return Collector
```
### get
Obtienes el valor de un key que este dentro del Collector
```js
Collector.get("Key") //return ['Value one', 'Value two']
```
### update
Actualizas el value de algun key
```js
Collector.update("Key",10)
```
### map
Mapeas los datos del Collector
```js
Collector.map(x => `Key: ${x.key} | Value: ${x.value}`) //return Array
```
### mapValues
Mapeas los valores del Collector
```js
Collector.mapValues(x => `Value: ${x}`) //return Array
```
### mapKeys
Mapeas los key del Collector
```js
Collector.mapKeys(x => `Key: ${x}`) //return Array
```
### every
Revisas si todos los datos del Collector cumplen con algo
```js
Collector.every(x => x.key === "Key") //return Boolean
```
### some
Revisas si algunos de los datos del Collector cumplen con algo
```js
Collector.some(x => x.key === "Key") //return Boolean
```
### clone
Clonas este Collector
```js
Collector.clone() //return new Collector
```
### first
El primer dato del Collector
```js
Collector.first() //return Object
```
### last
El ultimo dato del Collector
```js
Collector.last() //return Object
```
### find
Buscas algun dato del Collector
```js
Collector.find(x => x.key === "Key") //return Object
```
### findAndDelete
Buscas algun dato del Collector y lo eliminas
```js
Collector.findAndDelete(x => x.key.includes("K")) //return new Collector
```
### findKey
Buscas un key que cumpla con algo
```js
Collector.findKey(x => x.includes("K"))
```
### findValue
Buscas un value que cumpla con algo
```js
Collector.findValue(x => x.id === 12)
```
### filter
Te retorna los datos que cumplen el filtro que quieras
```js
Collector.filter(x => x.key.includes("K")) //return Array
```
### random
Te da un dato random del Collector
```js
Collector.random() //return Object
```
### randomKey
Te da un key random del Collector
```js
Collector.randomKey() //return String
```
### randomValue
Te da un value random del Collector
```js
Collector.randomValue() //return Value
```
### has
Te dice si el dato existe en el Collector
```js
Collector.has("Key") //return Boolean
```
### sort
Ordenas los datos del Collector (solo funciona con numeros)
```js
let Collection = require("collectors")
let collector = new Collection().set('Key1',{dinero:10}).set('Key2',{dinero:5}).set('Key3',{dinero:9})
collector.sort((example1,example2) => example2.dinero - example1.dinero) //return new Collector pero ordenado
```
### forEach
Obtienes todos los datos del Collector
```js
Collector.forEach((x) => console.log(x)) //return Collector
```
### equals
Revisas si un Collector es el mismo que este collector (si tienen los mismos datos)
```js
Collector.equals(new Collection().set("key","10")) //return Boolean
```
### equalsValues
Revisas si una key tiene los mismos values que otra
```js
Collector.equalsValues("Key","Test") //return Boolean
```
### concat
Combinas Collectors para obtener uno solo
```js
Collector.concat(new Collection().set('key',"09")) //return new Collector
```
### position
Te da la posicion de un elemento (el index)
```js
Collector.position("Key") //return Number
```
### hasAll
Revisas si el Collector tiene todas las keys que pones
```js
Collector.hasAll("Test","Test2") //retorna Boolean (false ya que estos dato no existen en el Collector)
```
### hasAny
Revisas si el Collector tiene algunos de las keys que pones
```js
Collector.hasAny("Key","Test") //retorna Bollean (true ya que si existe el key "Key")
```
### toJson
Te da todos los datos en un formato json o Object
```js
Collector.toJson() //return Object
```
### toString
Te da todos los datos en un formato str o String
```js
Collector.toString() //return String
```

Si tienen errores pueden mandarme solicitud en Discord, tag: `Jorge&#2276`
-

[regresar al inicio](https://www.npmjs.com/package/collectors#bienvenido)